/*				 3-Oct-90  3:06:14pm										*/

/*--------------------------------------------------------------------------*/
/*  History: gram.y, V0.0, ??-Nov-86 11:24:14am, Dan Dodge,	Baseline		*/
/*  				 V0.2, 13-Jan-87 11:24:14am, Dan Hildebrand				*/
/*----------------------------------------------------------------------------

	QCL - Grammar

----------------------------------------------------------------------------*/
%{
#include "qcl.h"
#include <term.h>

extern int		mdm;
extern int		capture_fd;
extern FILE		*files[ MAX_FILES ];
extern char		capture_on, filter8, debug, echo, secure, quiet;
extern char		*line_ptr, *line_table[];
extern int		yyline;
extern int		pass, yychar;
extern int		first_state;
extern int		last_state;
extern int		block_end_line;
extern int		qnx_terminal;
char			cval[2][50];	/* Alternate temp buffers	*/
int				i1, i2;
extern struct state_name state_table[ MAX_STATE ];
extern struct var_entry *retval, *cmdval, *collect, *failed, *switcher;
extern struct msg_line_s msg_line;
static char *months[] = {
					"???",	"Jan", 	"Feb", 	"Mar", 	"Apr", 	"May", 	"Jun",
					"Jul", 	"Aug", 	"Sep", 	"Oct", 	"Nov", 	"Dec" 	};
extern unsigned	okbd_mode, kbd_mode;

unsigned	saved_attr;
%}

%union __yystype
{
struct	var_entry	*vpval;
int					ival;
char				*cpval;
};

%term <vpval> _SVAR _VAR
%term <cpval> _STRING _CASE
%term <ival>  _PUTE _COMP _CON

%term _ACCESS _AND _BEEP _BOX _BREAK _BREAKABLE _CALL _CAPTURE _CARRIER
%term _CD _CLEAR _CLOSE _COLLECT _COLOUR _COMMENT _CURSOR _DATE
%term _DEC _DISPLAY _DROP _DROPLINE _DUMP _ECHO _ELSE _EMIT _END _EOFILE
%term _EOL _EXIT _FAST _FEQUAL _FILTER8 _FLUSH _GET _GOTO _IF _INC _INPUT
%term _ITOS _JUMP _LENGTH _MATCH _OFF _ON _OPEN _OR _PROTO _READQ _REPEAT
%term _RETURN _SECURE _SHELL _SLEEP _STATE _STOI _SWITCH _TAKE _TERMLOAD
%term _TIME _TOLOWER _TOUPPER _TRACE _UNBREAKABLE _WAITFOR _WHILE _WRITEQ

%type <ival> toggle expr relative not attr term co_ord
%type <cpval> string name

%left	'&'
%left	'|'
%binary	_AND _OR
%binary	_COMP
%left	'+'
%left	'-'
%left	_PUTE
%left	'!'
%left	_INC _DEC
%left	'('


%%

/*
prog:	decl statement_list
	|	statement_list
	;

decl:	_INT name_list _EOL
	|	_STR name_list _EOL
	;

name_list	:	_name_list _NAME
			|	_NAME
			;

*/
statement_list	:	statement_list statement ={
						reclaim_scratch();
						abort_check(0);
						}
				|	statement ={
						reclaim_scratch();
						abort_check(0);
						}
				;

statement	:	'{' _EOL statement_list '}' _EOL ={
					block_end_line = yyline;
					}
			|	_VAR '=' expr _EOL ={
					if ( pass == 2 )	$1->vint = $3;
					}
			|	_VAR '=' string _EOL ={
					if ( pass == 2 )	$1->vint = atoi( $3 );
					}
			|	_SVAR '=' string _EOL ={
					if ( pass == 1 ) {
						if ( !strcmp( $1->vname, "collect$" ) ) {
							yyerror( "Cannot assign to collect$ buffer." );
							done( -1 );
							}
						if ( !strcmp( $1->vname, "tcap$" ) ) {
							yyerror( "Cannot assign to tcap$ variable." );
							done( -1 );
							}
						}
					else {
						if ( $1->vstr ) _Free( $1->vstr );
						$1->vstr = mkstr( $3 );
						}
					}
			|	_INPUT _SVAR _EOL ={
					if ( pass == 1 ) {
						if ( strcmp( $2->vname, "collect$" ) == 0 ) {
							yyerror( "Cannot assign to collect$ buffer." );
							done( -1 );
							}
						}
					else {
						if ( $2->vstr ) _Free( $2->vstr );
						$2->vstr = Input();
						}
					}
			|	_SVAR '=' expr _EOL ={
					char	number[10];	/* Integers are less than 10 chars	*/

					if ( pass == 2 ) {
						if ( $1->vstr ) _Free( $1->vstr );
						sprintf( number, "%d", $3 );
						$1->vstr = mkstr( number );
						}
					}
			|	_BEEP _EOL ={
					if ( !quiet ) {
						fflush( ct->_outputfp );
						write( 1, "\007", 1 );
						}
					}
			|	_BEEP expr _EOL ={
					int i = $2;

					while( i-- && !quiet ) {
						fflush( ct->_outputfp );
						write( 1, "\007", 1 );
						delay( 25 );
						abort_check(0);
						}
					}
			|	_BREAK _EOL ={			tcsendbreak( mdm, 500 ); }
			|	_BOX expr ',' expr ',' expr ',' expr _EOL ={
					if ( !quiet ) term_box( $2, $4, $6, $8, 0 );
					}
			|	_BOX expr ',' expr ',' expr ',' expr ',' expr _EOL ={
					if ( !quiet ) term_box( $2, $4, $6, $8, $10 );
					}
			|	_BREAKABLE _EOL ={		signal( SIGINT, &abort_check );	}
			|	_CALL name _EOL ={		enter( $2, FALSE );	}
			|	_CAPTURE _EOL ={
					if ( capture_fd != -1 ) close( capture_fd );
					capture_on = 0;
					capture_fd = -1;
					}
			|	_CAPTURE string _EOL ={
					if ( capture_fd != -1 ) close( capture_fd );
					if ( (capture_fd = open( $2, O_CREAT|O_WRONLY|O_APPEND, 0644 )) != -1 )
						capture_on = 1;
					}
			|	_CAPTURE toggle _EOL	={	if ( capture_fd != -1 ) capture_on = $2;	}
			|	case_head statement ={
					if ( pass == 1 )	end_cond( 0 );
					}
			|	_CD string _EOL		={	failed->vint = chdir( $2 );	}
			|	_CLEAR _EOL			={
					if ( !quiet ) term_clear( 3 );
					}
			|	_CLEAR expr _EOL	={
					if ( !quiet ) term_clear( $2 );
					}
			|	_CLOSE expr _EOL ={
					if ( !files[ $2 ] )
						yyerror( "Cannot close '%d'. File not open.", $2 );
					else fclose( files[ $2 ] );
					files[ $2 ] = NULL;
					}
			|	_COLLECT expr ',' expr _EOL ={
					Collect( $2, $4 );
					}
			|	_COLLECT expr ',' expr ',' expr _EOL ={
					Collect( $2, $4 );
					}
			|	_COLOUR expr _EOL ={
					if ( !quiet ) {
						saved_attr = $2 & 0xff00 ? $2 : $2 << 8;
						term_color( saved_attr );
						term_fill( saved_attr );
						term_flush();
						}
					}
			|	_CURSOR expr ',' expr _EOL ={
					if ( !quiet ) {
						term_cur( $2, $4 );
						term_flush();
						}
					}
			|	_DISPLAY co_ord string attr _EOL ={
					Display( $2, $3, $4 );
					}
			|	_DROPLINE _EOL		={	tcdropline( mdm, 500 );	}
			|	_DUMP _EOL			={	dump_variables();		}
			|	_ECHO toggle _EOL	={
					if ( pass == 2 )	echo = $2;
					}
			|	_EMIT string _EOL	={
					if ( pass == 2 )	Emit( $2, 0 );
					}
			|	_EMIT string ',' _ECHO _EOL ={
					if ( pass == 2 )	Emit( $2, 1 );
					}
			|	_EMIT string ',' _FAST _EOL ={
					if ( pass == 2 )	Emit( $2, 2 );
					}
			|	_END _EOL			={	if ( !quiet ) term_flush(); YYACCEPT; }
			|	_EXIT _EOL			={	done( 0 ); 			}
			|	_EXIT expr _EOL		={	done( $2 );			}
			|	_FILTER8 toggle _EOL ={	filter8 = $2;		}
			|	_FLUSH _EOL			={	tcdrain( mdm );		}
			|	_GOTO name _EOL		={	enter( $2, TRUE );	}
			|	if_head statement	={
					if ( pass == 1 )	end_cond( 0 );
					}
			|	if_else_head statement {
					if ( pass == 1 )	end_cond( 0 );
					}
			|	_JUMP relative expr _EOL ={
					Jump( $2, $3 );
					}
			|	repeat_head statement ={
					if ( pass == 1 )	end_cond( 1 );
					}
			|	_PROTO expr ',' expr ',' string _EOL ={
					if ( pass == 2 ) failed->vint = proto_emit( $2, $4, $6 );
					}
			|	_OPEN expr ',' string ',' string _EOL ={
					failed->vint = FALSE;
					if ( $2 >= MAX_FILES ) {
						yyerror( "File number '%d' is too high ( 0 to %d ).", $2, MAX_FILES );
						done( -1 );
						}
					if ( files[$2] ) {
						yyerror( "File number '%d' already in use.", $2 );
						done( -1 );
						}
					if ( !( files[$2] = fopen( $4, $6 ) ) )
						failed->vint = TRUE;
					}
			|	_RETURN _EOL ={
					if ( pass == 2 ) Return( 0 );
					}
			|	_SECURE toggle _EOL	={	secure = $2;		}
			|	_RETURN expr _EOL ={
					if ( pass == 2 ) Return( $2 );
					}
			|	_SHELL '(' string ')' _EOL ={
					dev_mode( 0, okbd_mode, _DEV_MODES );
					cmdval->vint = system( $3 );
					dev_mode( 0, kbd_mode, _DEV_MODES );
					}
			|	_SLEEP expr _EOL ={	sleep( $2 );	}
			|	_STATE name _EOL ={
					int i;

					if ( pass == 1 ) {
						for ( i = 0; i < last_state; ++i )
							if ( !strcmp( state_table[i].name, $2 ) ) {
								yyerror( "Duplicate state name '%s'", $2 );
								done( -1 );
								}
						state_table[ last_state ].first_line = yyline;
						state_table[ last_state++ ].name = $2;
						if ( last_state >= MAX_STATE ) {
							yyerror( "Too many states defined." );
							done( -1 );
							}
						}
					}
			|	_SWITCH _SVAR _EOL	={	switcher = $2;	}
			|	_TERMLOAD _EOL ={
					/* Can't re-term_load in QNX4 ... */;
					}
			|	_TRACE toggle _EOL	={	debug = $2;					}
			|	_UNBREAKABLE _EOL	={	signal( SIGINT, SIG_IGN );	}

			|	_WRITEQ expr ',' string _EOL ={
					int str_length;
					if ( !files[$2] ) {
						yyerror( "File '%d' is not open.", $2 );
						done( -1 );
						}
					str_length = strlen( $4 );
					if ( 1 != fwrite( $4, str_length, 1, files[$2] ) ) {
						yyerror( "Write error to file '%d'.", $2 );
						done( -1 );
						}
					}
			|	while_head statement ={
					if( pass == 1 )		end_cond( 1 );
					}
			|	_VAR _INC _EOL ={		++$1->vint;			}
			|	_VAR _DEC _EOL ={		--$1->vint;			}
			|	_EOL
			;

if_head	:	_IF expr ={
				if ( pass == 1 )	beg_cond( _IF );
				else if ( $2 == 0 ) {	/* Skip it */
					line_ptr = "\n";
					yychar = -1;
					} 
				}
		;

if_else_head:	if_head statement _ELSE ={
					if ( pass == 1 )	else_cond();
					else	yyerror( "Interal compiler error 0001" );
					}
			;

case_head:	_CASE not string ={
				if ( pass == 1 )	beg_cond( _IF );
				else if ( Case( $3 ) != $2 ) {	/* Skip it */
					line_ptr = "\n";
					yychar = -1;
					}
				}
		;

while_head:	_WHILE expr ={
				if ( pass == 1 )	beg_cond( _WHILE );
				else if ( $2 == 0 ) {	/* Skip it */
					line_ptr = "\n";
					yychar = -1;
					}
				}
		;

repeat_head:	_REPEAT expr ={
					if ( pass == 1 )	beg_cond( _REPEAT );
					}
			;

co_ord	:	expr ',' expr ','	={	$$ = ($1 << 8) | ($3 & 0xff);	}
		|						={	$$ = -1;	}
		;

attr	:	',' expr	={		$$ = $2;	}
		|				={		$$ = saved_attr/*0*/;		}
		;

relative:	'.' '+' ={		$$ = 1;		}
		|	'.' '-' ={		$$ = -1;	}
		|			={		$$ = 0;		}
		;

not		:	'!' ={		$$ = 0; 	}
		|		={		$$ = 1; 	}
		;

name	:	_VAR ={
/*				$1->vstr = $1->vname;	Make this an unusable integer @@@	*/
				$$ = $1->vname;
				}
		;

toggle	:	_ON	={	$$ = 1;		}
		|	_OFF ={ $$ = 0;		}
		;

string	:	_STRING ={		$$ = $1;			}
		|	_SVAR ={
				if ( pass == 2 ) $$ = $1->vstr;
				}
		|	string '+' string ={
 				static char *temp = NULL, *temp2 = NULL;

				if ( pass == 2 ) {
					i1 = strlen( $1 );
					i2 = strlen( $3 );
					if ( !temp )	$$ = temp  = _Malloc( i1 + i2 + 1 );
					else			$$ = temp2 = _Malloc( i1 + i2 + 1 );
					strncpy( $$, $1, i1 );
					strcpy( $$ + i1, $3 );
					if ( temp  && temp2 )	_Free( temp );
					if ( temp2 )			temp = temp2;
					}
				}
		|	_DATE ={
				static char date[ 10 ];

				if ( pass == 2 ) {
					struct	tm	*tm;
					long		t;
	
					t = time( NULL );
					tm = localtime( &t );
					sprintf( date, "%02d%s%02d",
									tm->tm_mday,
									months[ tm->tm_mon+1 ],
									tm->tm_year );
					$$ = date;
					}
				}
		|	_DROP '(' string ',' expr ')' ={
				if ( pass == 2 ) $$ = Drop( $3, $5 );
				}
		|	_DROP '(' string ',' string ')' ={
				if ( pass == 2 ) $$ = Drop_str( $3, $5, 1 );
				}
		|	_DROP '(' string ',' '-' string ')' ={
				if ( pass == 2 ) $$ = Drop_str( $3, $6, 0 );
				}
		|	_GET '(' expr ')' ={
				static char	get_line[2];		/* leave space for null		*/

				if ( pass == 2 ) {
					if ( !files[$3] ) {
						yyerror( "File '%d' is not open.", $3 );
						done( -1 );
						}
					if ( (quiet && ($3==0)) || (!isatty(0) && ($3==0)) ) get_line[0] = '\0';
					else fread( &get_line[0], 1, 1, files[$3] );
					get_line[1] = '\0';
					$$ = get_line;
					}
				}
		|	_ITOS '(' string ',' expr ')' ={
				static int which;

				if ( pass == 2 ) {
					$$ = cval[ which = !which ]; /* @@@ Buffer overflow ?	*/
					sprintf( $$, $3, $5 );
					}
				}
		|	_READQ '(' expr ')' ={
				static char	read_line[133];		/* leave space for null		*/

				if ( pass == 2 ) {
					if ( !files[ $3 ] ) {
						yyerror( "File '%d' is not open.", $3 );
						done( -1 );
						}
					fgetln( files[ $3 ], read_line, 132 );
					$$ = read_line;
					}
				}
		|	_TAKE '(' string ',' expr ')' ={
				if ( pass == 2 ) $$ = Take( $3, $5 );
				}
		|	_TAKE '(' string ',' string ')' ={
				if ( pass == 2 ) $$ = Take_str( $3, $5, 1 );
				}
		|	_TAKE '(' string ',' '-' string ')' ={
				if ( pass == 2 ) $$ = Take_str( $3, $6, 0 );
				}
		|	_TIME ={
				static char timestr[ 10 ];

				if ( pass == 2 ) {
					struct	tm	*tm;
					long		t;

					t = time( NULL );
					tm = localtime( &t );
					sprintf( timestr, "%02d:%02d:%02d",
						tm->tm_hour, tm->tm_min, tm->tm_sec );
					$$ = timestr;
					}
				}
		|	_TOLOWER '(' string ')' ={
				if ( pass == 2 ) {
					//_Free( $$ );
					$$ = Tolower( $3 );
					}
				}
		|	_TOUPPER '(' string ')' ={
				if ( pass == 2 ) {
					//_Free( $$ );
					$$ = Toupper( $3 );
					}
				}
		;

expr:	expr _PUTE expr	={		$$ = compute( $1, $2, $3 );	}
	|	expr '+' expr	={		$$ = $1 + $3;				}
	|	expr '-' expr	={		$$ = $1 - $3;				}
	|	expr '&' expr	={		$$ = ($1 & $3);				}
	|	expr _AND expr	={		$$ = ($1 && $3);			}
	|	expr '|' expr	={		$$ = ($1 | $3);				}
	|	expr _OR expr	={		$$ = ($1 || $3);			}
	|	expr _COMP expr ={		$$ = compare( $1, $2, $3 );	}
	|	term			={		$$ = $1;	 				}
	;

term:	_CON			={		$$ = $1; 			}
	|	_VAR			={		$$ = $1->vint;		}
	|	_INC _VAR		={		$$ = ++$2->vint;	}
	|	_DEC _VAR		={		$$ = --$2->vint;	}
	|	_VAR _INC		={		$$ = $1->vint++;	}
	|	_VAR _DEC		={		$$ = $1->vint--;	}
	|	'!' expr		={		$$ = !$2; 			}
	|	'(' expr ')'	={		$$ = $2; 			}
	|	'-' expr		={		$$ = -$2; 			}
	|	_ACCESS '(' string ',' expr ')' ={
			if ( pass == 2 ) $$ = access( $3, $5 );
			}
	|	_CARRIER '(' ')' ={
			if ( pass == 2 ) {
#include <sys/qioctl.h>
				long	bits[2];
				memset( &bits, 0, sizeof(bits) );
				/* QCTL_DEV_CTL == 0x303 */
				if ( qnx_ioctl( mdm, 0x303, &bits, 8, &bits, 4 ) != -1 )
					$$ = bits[0] & 0x800000L ? 1 : 0;
				else
					$$ = 0;
				}
			}
	|	_FEQUAL '(' string ',' string ')' ={
			if ( pass == 2 ) $$ = strcmp( $3, $5 ) == 0;
			}
	|	_FEQUAL '(' expr ',' expr ')' ={
			if ( pass == 2 ) $$ = ($3 == $5);
			}
	|	_FEQUAL '(' expr ',' string ')' ={
			if ( pass == 2 ) $$ = ($3 == atoi($5) );
			}
	|	_FEQUAL '(' string ',' expr ')' ={
			if ( pass == 2 ) $$ = ( atoi($3) == $5);
			}
	|	_EOFILE '(' expr ')' ={
			if ( pass == 2 ) {
				if ( !files[ $3 ] ) {
					yyerror( "File '%d' is not open.", $3 );
					$$ = TRUE;		/* Force end of file	*/
					}
				$$ = feof( files[ $3 ] );
				}
			}
	|	_MATCH '(' string ',' string ')' ={
			if ( pass == 2 ) $$ = ( fnmatch( $5, $3, 0 ) == 0 );
			}
	|	_STOI '(' expr ',' string ')' ={
			if ( pass == 2 ) $$ = (int) strtol( $5, NULL, $3 );
			}
	|	_LENGTH '(' string ')' ={
			if ( pass == 2 ) $$ = strlen( $3 );
			}
	|	_WAITFOR '(' string ',' expr ')' ={
			if ( pass == 2 ) $$ = Waitfor( $3, $5, 2 );
			}
	|	_WAITFOR '(' string ',' expr ',' expr ')' ={
			if ( pass == 2 ) $$ = Waitfor( $3, $5, $7 );
			}
	;
